;*****************************************************************************
;*
;*               Laborator SMP - Runtime 80386EX Z3/EV Real Mode
;*
;*    Portions Copyright (c) 2010 Mihai Matei. All Rights Reserved.
;*
;*  ========================================================================
;*
;*    This file contains Original Code and/or Modifications of Original
;*    Code as defined in and that are subject to the Apache License,
;*    Version 2.0 (the "License"). You may not use this file
;*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
;*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
;*    provided with the Original Code and Modifications, and is also
;*    available at http://www.apache.org/licenses/LICENSE-2.0
;*
;*    The Original Code and all software distributed under the License are
;*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
;*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
;*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
;*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
;*    NON-INFRINGEMENT. Please see the License for the specific language
;*    governing rights and limitations under the License.
;*
;*  ========================================================================
;*
;* Description:  90386EX Module Z3/EV 16-bit startup code.
;*
;*****************************************************************************

.286p

                name    z3cstart

                assume  nothing

; Set the defined segments in a GROUP in order to be accesed with one segment register
DGROUP group _TEXT, _DATA, DATA, _BSS, STACK

_TEXT   segment word public 'CODE'
                extrn   __z3CMain                 : near

                assume  ds:DGROUP

                public _small_code_
_DATA   segment word public 'DATA'

                _small_code_    db 0

_DATA   ends

DATA    segment word public 'DATA'
DATA    ends

_BSS    segment word public 'BSS'

                extrn   _edata                  : byte  ; end of DATA (start of BSS)
                extrn   _end                    : byte  ; end of BSS (start of STACK)

_BSS    ends

; set the stack size to 2KB
STACK_SIZE      equ     800h
STACK   segment para stack 'STACK'

                db      (STACK_SIZE) dup(?)

STACK   ends

;
; 80386EX Z3/EV always runs in Real Mode, set the ENTRY POINT to CS:0x0
;
                assume  nothing
                assume  cs:_TEXT                ; the CS assumed to be at start of the code segment _TEXT = DGROUP
                org     00h
_z3cstart_ proc near
                public  _cstart_

                assume  ds:DGROUP, es:DGROUP, ss:DGROUP
                mov     cx,cs                   ; get the address of the code segment
                mov     ds,cx                   ; set the data segment DS=CS
                mov     es,cx                   ; set the extended segment ES=CS      

                mov     bx,offset DGROUP:_end   ; get bottom of stack
                mov     ax,STACK_SIZE           ; set stack size
                add     bx,ax                   ; calc top address for stack
                add     bx,0Fh                  ; round up to paragraph boundary
                and     bl,0F0h                 ; ...
                mov     ss,cx                   ; set stack segment SS=CS
                mov     sp,bx                   ; set sp relative to DGROUP

                xor     bp,bp                   ; set up stack frame
                ; DON'T MODIFY BP FROM THIS POINT ON!

                mov     cx,offset DGROUP:_end   ; end of _BSS segment (start of STACK)
                mov     di,offset DGROUP:_edata ; start of _BSS segment
                sub     cx,di                   ; calc # of bytes in _BSS segment
                mov     al,0                    ; zero the _BSS segment
                rep     stosb                   ; . . .

                call    __z3CMain               ; call the C Runtime main
_z3cstart_ endp


; don't touch AL in __exit, it has the return code
__z3exit  proc near
                public  "C",__z3exit

                int     07h                     ; Back to Z3/EV Monitor
__z3exit  endp

_TEXT   ends

                end     _z3cstart_
